 // FOPVisioStencilHelper.h: interface for the CFOPVisioStencilHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FOPVISIOSTENCILHELPER_H__D2447491_E960_4714_BB0B_965507390EAF__INCLUDED_)
#define AFX_FOPVISIOSTENCILHELPER_H__D2447491_E960_4714_BB0B_965507390EAF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XDXml.h"
#include "FOCompList.h"

// zhj
#ifndef _SafeDeletePtr
#define _SafeDeletePtr(ptr)		if(ptr!=NULL) {delete ptr; ptr = NULL;}
#endif
#ifndef _SafeDeletePtrArr
#define _SafeDeletePtrArr(ptr)	if ((ptr) != NULL) { delete [](ptr); (ptr) = NULL; }
#endif
#ifndef _SafeDeletePtrArrBySize
#define _SafeDeletePtrArrBySize(size,ptr) if(size != 0) {delete []ptr; ptr = NULL; size = 0;}
#endif

//===========================================================================
// Summary:
//     The IBaseHelper class derived from CObject
//      Base Helper
//===========================================================================

class IBaseHelper : public CObject
{
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node)---Specifies a CXDXmlNode node) = 0 object.
	virtual void ApplyStyle(CXDXmlNode node) = 0;
};

 
//===========================================================================
// Summary:
//     The HelperFillStyle class derived from IBaseHelper
//      Helper Fill Style
//===========================================================================

class HelperFillStyle : public IBaseHelper
{
public:
 
	// Inherited From, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nInheritedFrom;
 
	// Search For, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSearchFor;

 
	// Fill Background, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrFillBkgnd;
 
	// Fill Foregnd, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrFillForegnd;
 
	// Fill Pattern, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nFillPattern;
 
	// Fill Foregnd Transparency, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fFillForegndTransparency;
 
	// Fill Background Transparency, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fFillBkgndTransparency;
	
 
	// No Fill, Specify A Boolean value.  
	bool m_bNoFill;
 
	// Shdw Background, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrShdwBkgnd;
 
	// Shdw Foregnd, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrShdwForegnd;
 
	// Shdw Pattern, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nShdwPattern;
 
	// Shdw Offset X, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nShdwOffsetX;
 
	// Shdw Offset Y, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nShdwOffsetY;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Helper Fill Style, Constructs a HelperFillStyle object.
	//		Returns A  value.
	HelperFillStyle()
	{
		m_nFillPattern = -1;
		m_fFillForegndTransparency = -1;
		m_fFillBkgndTransparency = -1;
		
		m_nShdwPattern = -1;
		m_nShdwOffsetX = -1;
		m_nShdwOffsetY = -1;
		
		m_nInheritedFrom = -1;

		m_strSearchFor = _T("FillStyle");
	}

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.
	virtual void ApplyStyle(CXDXmlNode node) {};
};

 
//===========================================================================
// Summary:
//     The HelperLineStyle class derived from IBaseHelper
//      Helper Line Style
//===========================================================================

class HelperLineStyle : public IBaseHelper
{
public:
 
	// Inherited From, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nInheritedFrom;
 
	// Search For, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSearchFor;
	
 
	// No Line, Specify A Boolean value.  
	bool m_bNoLine;
 
	// Line Color, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrLineColor;
 
	// Line Weight, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fLineWeight;
 
	// Line Pattern, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nLinePattern;
 
	// Line Cap, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nLineCap;
 
	// m_fTransparency, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fTransparency;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Helper Line Style, Constructs a HelperLineStyle object.
	//		Returns A  value.
	HelperLineStyle()
	{
		m_nInheritedFrom = -1;
		
		m_fLineWeight = -1;
		m_nLinePattern = -1;
		m_nLineCap = -1;
		m_fTransparency = -1;

		m_strSearchFor = _T("LineStyle");
	}

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.
	virtual void ApplyStyle(CXDXmlNode node) {};
};

 
//===========================================================================
// Summary:
//     The HelperTextStyle class derived from IBaseHelper
//      Helper Text Style
//===========================================================================

class HelperTextStyle : public IBaseHelper
{
public:
 
	// Inherited From, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nInheritedFrom;
 
	// Search For, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSearchFor;
	
 
	// Text Background, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrTextBkgnd;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Helper Text Style, Constructs a HelperTextStyle object.
	//		Returns A  value.  
	// Parameters:
	//		---Specifies a  object.
	HelperTextStyle( )
	{
		m_nInheritedFrom = -1;

		m_strSearchFor = _T("TextStyle");
	}

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.
	virtual void ApplyStyle(CXDXmlNode node) {};
};	

 
//===========================================================================
// Summary:
//     The HelperCharStyle class derived from IBaseHelper
//      Helper Char Style
//===========================================================================

class HelperCharStyle : public IBaseHelper
{
public:	
 
	// Inherited From, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nInheritedFrom;
 
	// Search For, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSearchFor;
	
 
	// Font I D, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nFontID;
 
	// Text Color, This member sets A 32-bit value used as a color value.  
	COLORREF m_clrTextColor;
 
	// Font Size, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fFontSize;
 
	// Lang I D, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nLangID;
 
	// m_enumStyle, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_enumStyle;
 
	// m_nCase, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nCase;
 
	// R T L, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nRTL;
 
	// Strike Through, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nStrikeThrough;
 
	// Double Underline, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nDoubleUnderline;
 
	// m_nVertical, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nVertical;
 
	// m_nSpacing, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nSpacing;
 
	// m_nPosition, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nPosition;
 
	// Font Scale, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fFontScale;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Helper Char Style, Constructs a HelperCharStyle object.
	//		Returns A  value.  
	// Parameters:
	//		---Specifies a  object.
	HelperCharStyle( )
	{
		m_nInheritedFrom = -1;
		m_strSearchFor = _T("TextStyle");
		
		// Char
		m_fFontScale = -1;
		m_nPosition = -1;
		m_nSpacing = -1;
		m_nFontID = -1;
		m_fFontSize = -1;
		m_nLangID = -1;
		m_nRTL = -1;
		m_nStrikeThrough = -1;
		m_nDoubleUnderline = -1;
		m_nVertical = -1;
		m_nCase = -1;
	}
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.
	virtual void ApplyStyle(CXDXmlNode node) {};
};

 
//===========================================================================
// Summary:
//     The HelperParaStyle class derived from IBaseHelper
//      Helper Para Style
//===========================================================================

class HelperParaStyle : public IBaseHelper
{
public:	
 
	// Inherited From, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nInheritedFrom;
 
	// Search For, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strSearchFor;
	
	// ParaBlock
 
	// Ind First, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fIndFirst;
 
	// Ind Left, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fIndLeft;
 
	// Ind Right, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fIndRight;
 
	// Sp Line, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fSpLine;
 
	// Sp Before, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fSpBefore;
 
	// Sp After, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fSpAfter;
 
	// Horizontal Align, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nHorzAlign;
 
	// Text Position After Bullet, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fTextPosAfterBullet;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Helper Para Style, Constructs a HelperParaStyle object.
	//		Returns A  value.
	HelperParaStyle()
	{
		m_nInheritedFrom = -1;
		m_strSearchFor = _T("TextStyle");
		
		m_fIndFirst = -1;
		m_fIndLeft = -1;
		m_fIndRight = -1;
		m_fSpLine = -1;
		m_fSpBefore = -1;
		m_fSpAfter = -1;
		m_nHorzAlign = -1;
		m_fTextPosAfterBullet = -1;
	}
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Apply Style, None Description.
	// This member function is also a virtual function, you can Override it if you need,  
	// Parameters:
	//		node---Specifies a CXDXmlNode node object.
	virtual void ApplyStyle(CXDXmlNode node) {};
};

 
//===========================================================================
// Summary:
//      To use a SymbolPalette object, just call the constructor.
//      Symbol Palette
//===========================================================================

class SymbolPalette
{
public: 
	// Store palette name.
 
	// Palette Name, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strPaletteName;
};

 
//===========================================================================
// Summary:
//      To use a EditStyle object, just call the constructor.
//      Edit Style
//===========================================================================

class EditStyle
{
public:
	// Flag enum used to store EditStyle
	enum InternalEditStyle
	{
		// Flag indicating whether node can be selected.
		ALLOW_SELECT = 1,
		// Flag indicating whether node can be selected.
		ALLOW_DELETE = 2,
		// Flag indicating whether node's vertexes can be edited.
		ALLOW_VERTEX_EDIT = 4,
		// Flag indicating whether node can be moved by X axis.
		ALLOW_MOVE_BY_X_AXIS = 8,
		// Flag indicating whether node can be moved by Y axis.
		ALLOW_MOVE_BY_Y_AXIS = 16,
		// Flag indicating whether node can be rotated.
		ALLOW_ROTATE = 32,
		// Flag indicating whether node's width can be changed.
		ALLOW_CHANGE_WIDTH = 64,
		// Flag indicating whether node's height can be changed.
		ALLOW_CHANGE_HEIGHT = 128,
		// Flag indicating whether node's height can be changed.
		ASPECT_RATIO_RESIZE = 256,
		// Flag indicating whether node is enabled.
		ENABLED = 512
	};

private:
 
	// Edit Style, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nEditStyle;
//	HandleEditMode m_editMode;

public:
	// Default edit style constructor with all allowing.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Edit Style, Constructs a EditStyle object.
	//		Returns A  value.
	EditStyle()
	{
	
	//-----------------------------------------------------------------------
	// Summary:
	// Edit Style, Constructs a EditStyle object.
	//		Returns A  value.  
	// Parameters:
	//		&src---Specifies a EditStyle &src object.
		m_nEditStyle = ALLOW_CHANGE_HEIGHT | ALLOW_CHANGE_WIDTH
			| ALLOW_MOVE_BY_X_AXIS | ALLOW_MOVE_BY_Y_AXIS
			| ALLOW_ROTATE | ALLOW_SELECT| ALLOW_DELETE
			| ALLOW_VERTEX_EDIT | ENABLED;
	}

	EditStyle(EditStyle &src)
	{
		m_nEditStyle = src.m_nEditStyle;
	}

public:
// Property is obsolete.
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Resize, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowResize() { return GetAllowChangeHeight() && GetAllowChangeWidth(); }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Resize, Sets a specify value to current class EditStyle
	// Parameters:
	//		bAllowResize---Allow Resize, Specifies A Boolean value.
	void SetAllowResize(bool bAllowResize)
	{
		SetAllowChangeWidth(bAllowResize);
		SetAllowChangeHeight(bAllowResize);
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Move, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowMove() { return GetAllowMoveX() && GetAllowMoveY(); }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Move, Sets a specify value to current class EditStyle
	// Parameters:
	//		bAllowMove---Allow Move, Specifies A Boolean value.
	void SetAllowMove(bool bAllowMove)
	{
		SetAllowMoveX(bAllowMove);
		SetAllowMoveY(bAllowMove);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Delete, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowDelete() { return ( m_nEditStyle & ALLOW_DELETE ) == ALLOW_DELETE; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Delete, Sets a specify value to current class EditStyle
	// Parameters:
	//		bAllowDelete---Allow Delete, Specifies A Boolean value.
	void SetAllowDelete(bool bAllowDelete)
	{
		bool bOldValue = GetAllowDelete();

		if( bOldValue != bAllowDelete )
			AssignNewValue(_T("AllowDelete"), bAllowDelete);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Select, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowSelect() { return ( m_nEditStyle & ALLOW_SELECT ) == ALLOW_SELECT; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Select, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowSelect(bool bValue)
	{
		bool bOldValue = GetAllowSelect();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowSelect"), bValue);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Vertex Edit, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowVertexEdit() { return ( m_nEditStyle & ALLOW_VERTEX_EDIT ) == ALLOW_VERTEX_EDIT; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Vertex Edit, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowVertexEdit(bool bValue)
	{
		bool bOldValue = GetAllowVertexEdit();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowVertexEdit"), bValue);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Move X, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowMoveX() { return ( m_nEditStyle & ALLOW_MOVE_BY_X_AXIS ) == ALLOW_MOVE_BY_X_AXIS; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Move X, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowMoveX(bool bValue)
	{
		bool bOldValue = GetAllowMoveX();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowMoveX"), bValue);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Move Y, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowMoveY() { return ( m_nEditStyle & ALLOW_MOVE_BY_Y_AXIS ) == ALLOW_MOVE_BY_Y_AXIS; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Move Y, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowMoveY(bool bValue)
	{
		bool bOldValue = GetAllowMoveY();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowMoveY"), bValue);
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Rotate, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowRotate() { return ( m_nEditStyle & ALLOW_ROTATE ) == ALLOW_ROTATE; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Rotate, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowRotate(bool bValue)
	{
		bool bOldValue = GetAllowRotate();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowRotate"), bValue);
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Change Height, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowChangeHeight() { return ( m_nEditStyle & ALLOW_CHANGE_HEIGHT ) == ALLOW_CHANGE_HEIGHT; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Change Height, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowChangeHeight(bool bValue)
	{
		bool bOldValue = GetAllowChangeHeight();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowChangeHeight"), bValue);
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Allow Change Width, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAllowChangeWidth() { return ( m_nEditStyle & ALLOW_CHANGE_WIDTH ) == ALLOW_CHANGE_WIDTH; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Allow Change Width, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAllowChangeWidth(bool bValue)
	{
		bool bOldValue = GetAllowChangeWidth();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AllowChangeWidth"), bValue);
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Aspect Ratio, Returns the specified value.
	//		Returns A Boolean value.
	bool GetAspectRatio() { return ( m_nEditStyle & ASPECT_RATIO_RESIZE ) == ASPECT_RATIO_RESIZE; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Aspect Ratio, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetAspectRatio(bool bValue)
	{
		bool bOldValue = GetAspectRatio();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("AspectRatio"), bValue);
	}
	
	
	//-----------------------------------------------------------------------
	// Summary:
	// Get Enabled, Returns the specified value.
	//		Returns A Boolean value.
	bool GetEnabled() { return ( m_nEditStyle & ENABLED ) == ENABLED; }
	
	//-----------------------------------------------------------------------
	// Summary:
	// Set Enabled, Sets a specify value to current class EditStyle
	// Parameters:
	//		bValue---bValue, Specifies A Boolean value.
	void SetEnabled(bool bValue)
	{
		bool bOldValue = GetEnabled();
		
		if( bOldValue != bValue )
			AssignNewValue(_T("Enabled"), bValue);
	}

private:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Assign New Value, None Description.
	// Parameters:
	//		strPropertyName---Property Name, Specifies A CString type value.  
	//		newValue---newValue, Specifies A Boolean value.
	void AssignNewValue( CString strPropertyName, bool newValue )
	{
		if (strPropertyName == _T("AllowSelect"))
		{
			if( newValue )
				m_nEditStyle = (InternalEditStyle)(m_nEditStyle | ALLOW_SELECT);
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_SELECT );
		}
		else if (strPropertyName == _T("AllowDelete"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_DELETE;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_DELETE );
		}
		else if (strPropertyName == _T("AllowMoveX"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_MOVE_BY_X_AXIS;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_MOVE_BY_X_AXIS );
		}
		else if (strPropertyName == _T("AllowMoveY"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_MOVE_BY_Y_AXIS;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_MOVE_BY_Y_AXIS );
		}
		else if (strPropertyName == _T("AllowVertexEdit"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_VERTEX_EDIT;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_VERTEX_EDIT );
		}
		else if (strPropertyName == _T("AllowRotate"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_ROTATE;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_ROTATE );
		}
		else if (strPropertyName == _T("AllowChangeHeight"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_CHANGE_HEIGHT;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_CHANGE_HEIGHT );
		}
		else if (strPropertyName == _T("AllowChangeWidth"))
		{
			if( newValue )
				m_nEditStyle |= ALLOW_CHANGE_WIDTH;
			else
				m_nEditStyle = m_nEditStyle & ( ~ALLOW_CHANGE_WIDTH );
		}
		else if (strPropertyName == _T("AspectRatio"))
		{
			if( newValue )
				m_nEditStyle |= ASPECT_RATIO_RESIZE;
			else
				m_nEditStyle = m_nEditStyle & ( ~ASPECT_RATIO_RESIZE );
		}
		else if (strPropertyName == _T("Enabled"))
		{
			if( newValue )
				m_nEditStyle |= ENABLED;
			else
				m_nEditStyle = m_nEditStyle & ( ~ENABLED );
		}
	}
};

 
//===========================================================================
// Summary:
//      To use a Group object, just call the constructor.
//      Group
//===========================================================================

class Group
{	
public:
 
	// m_strName, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strName;
 
	// m_szSize, This member sets a CSize value.  
	CSize m_szSize;
 
	// Pin Point, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	CPoint m_ptPinPoint;
 
	// Pin Point Offset;, This member sets a CSize value.  
	CSize m_szPinPointOffset;;
 
	// Rotation Angle, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fRotationAngle;
 
	// Flip X, Specify A Boolean value.  
	bool m_bFlipX;
 
	// Flip Y, Specify A Boolean value.  
	bool m_bFlipY;
	
 
	// Edit Style, This member specify EditStyle object.  
	EditStyle m_nEditStyle;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Group, Constructs a Group object.
	//		Returns A  value.
	Group()
	{
		m_strName = _T("");
		m_szSize = CSize(0, 0);
		m_ptPinPoint = CPoint(0, 0);
		m_szPinPointOffset = CSize(0, 0);
		m_fRotationAngle = 0.0f;
		m_bFlipX = 0;
		m_bFlipY = 0;
	}

	
	//-----------------------------------------------------------------------
	// Summary:
	// Equals, None Description.
	//		Returns A Boolean value.  
	// Parameters:
	//		&group---Specifies a Group &group object.
	bool Equals(Group &group)
	{
		return (group.m_strName == m_strName);
	}
};

 
//===========================================================================
// Summary:
//      To use a XForm object, just call the constructor.
//      Form
//===========================================================================

class XForm
{
public:
 
	// Rotation Angle, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fRotationAngle;
 
	// m_fHeight, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fHeight;
 
	// m_fWidth, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fWidth;
 
	// Flip X, Specify A Boolean value.  
	bool m_bFlipX;
 
	// Flip Y, Specify A Boolean value.  
	bool m_bFlipY;
 
	// Pin X, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fPinX;
 
	// Pin Y, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fPinY;
 
	// Loc Pin X, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fLocPinX;
 
	// Loc Pin Y, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fLocPinY;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Form, Constructs a XForm object.
	//		Returns A  value.
	XForm()
	{
		m_fRotationAngle = 0.0f;
		m_fHeight = 0.0f;
		m_fWidth = 0.0f;
		m_bFlipX = false;
		m_bFlipY= false;
		m_fPinX = 0.0f;
		m_fPinY = 0.0f;
		m_fLocPinX = 0.0f;
		m_fLocPinY = 0.0f;
	}
};

 
//===========================================================================
// Summary:
//      To use a ForeignImageInfo object, just call the constructor.
//      Foreign Image Information
//===========================================================================

class ForeignImageInfo
{
public:
 
	// Image Width, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nImageWidth;
 
	// Image Height, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nImageHeight;
 
	// Offset X To Origin, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fOffsetXToOrigin;
 
	// Offset Y To Origin, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fOffsetYToOrigin;

	
	//-----------------------------------------------------------------------
	// Summary:
	// Foreign Image Information, Constructs a ForeignImageInfo object.
	//		Returns A  value.
	ForeignImageInfo()
	{
		m_nImageWidth = 0;
		m_nImageHeight = 0;
		m_fOffsetXToOrigin = 0.0;
		m_fOffsetYToOrigin = 0.0;
	}
};

 
//===========================================================================
// Summary:
//      To use a ConnectionPoint object, just call the constructor.
//      Connection Point
//===========================================================================

class ConnectionPoint
{
public:
 
	// Connections Limit, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nConnectionsLimit;
 
	// m_strName, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strName;

 
	// Offset X, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nOffsetX;
 
	// Offset Y, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	int m_nOffsetY;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Connection Point, Constructs a ConnectionPoint object.
	//		Returns A  value.
	ConnectionPoint()
	{
		m_nConnectionsLimit = 10;
	}
};

 
//===========================================================================
// Summary:
//      To use a BoundsInfo object, just call the constructor.
//      Bounds Information
//===========================================================================

class BoundsInfo
{
public:
 
	// Hit Test Padding, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fHitTestPadding;
 
	// Pin Point, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	CPoint m_ptPinPoint;
 
	// Pin Offset, This member sets a CSize value.  
	CSize m_szPinOffset;
 
	// m_szSize, This member sets a CSize value.  
	CSize m_szSize;
 
	// Unit Dependent Hit Test Padding, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fUnitDependentHitTestPadding;
 
	// Unit Dependent Pin Value, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	CPoint m_ptUnitDependentPinValue;
 
	// Unit Dependent Pin Offset Value, This member sets a CSize value.  
	CSize m_szUnitDependentPinOffsetValue;
 
	// Unit Dependent Size Value, This member sets a CSize value.  
	CSize m_szUnitDependentSizeValue;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Bounds Information, Constructs a BoundsInfo object.
	//		Returns A  value.
	BoundsInfo()
	{
	}
};

 
//===========================================================================
// Summary:
//      To use a Node object, just call the constructor.
//      Node
//===========================================================================

class Node
{
public:
	// Indicates whether LineRouter will treat this node as obstacle.
 
	// m_bObstacle, Specify A Boolean value.  
	bool m_bObstacle;

	// Reference to center port in port collection.
 
	// m_centralPort, This variable specifies a 32-bit signed integer on 32-bit platforms.  
	ConnectionPoint m_centralPort;

	// Indicated whether center port is enable.
 
	// Enable Central Port, Specify A Boolean value.  
	bool m_bEnableCentralPort;

	// Node's name.
 
	// m_strName, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString m_strName;

	// Indicates whether node is visible.
 
	// m_bVisible, Specify A Boolean value.  
	bool m_bVisible;

	// Helper member used to store previous hit test padding value.
	// If padding value is not equal to value stored in m_fPadding member
	// cached region used to hit test point is recreated.
 
	// m_fPadding, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fPadding;

	// Padding around the node used for hit testing.
 
	// Hit Test Padding, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fHitTestPadding;

 
	// m_boundsInternal, This member specify BoundsInfo object.  
	BoundsInfo m_boundsInternal;

	// Node's rotation angle.
 
	// Rotation Angle, This member specify The float keyword designates a 32-bit floating-point number.  
	float m_fRotationAngle;

	// Indicates whether node is flipped along X axis.
 
	// Flip X, Specify A Boolean value.  
	bool m_bFlipX;

	// Indicates whether node is flipped along Y axis.
 
	// Flip Y, Specify A Boolean value.  
	bool m_bFlipY;

	// Properties for determining edit capabilities.
 
	// m_styleEdit, This member specify EditStyle object.  
	EditStyle m_styleEdit;

 
	// Lock Update, Specify A Boolean value.  
	bool m_bLockUpdate;

	// Indicates whether node ports are visible.
 
	// Draw Ports, Specify A Boolean value.  
	bool m_bDrawPorts;

	// Indicates whether node's units will change on its container's MeasureUnits changing.
 
	// Inherit Container Units, Specify A Boolean value.  
	bool m_bInheritContainerUnits;

	// Indicate whether node updating self ports connections.
 
	// Port Updating, Specify A Boolean value.  
	bool m_bPortUpdating;

	CArray<ConnectionPoint, ConnectionPoint> m_ConnPtArray;

 
	// Edit Style, This member specify EditStyle object.  
	EditStyle m_nEditStyle;

public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// Node, Constructs a Node object.
	//		Returns A  value.
	Node()
	{
		m_strName = _T("");
		m_bVisible = true;
		m_bDrawPorts = true;
		m_bInheritContainerUnits = true;
		m_bObstacle = true;
		m_bPortUpdating = false;
	}
};

 
//===========================================================================
// Summary:
//      To use a CFOPMasterInfo object, just call the constructor.
//      F O P Master Information
//===========================================================================

class CFOPMasterInfo
{
public:
 
	// strName, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString strName;
 
	// strPrompt, You can freely substitute CString objects for const char* and LPCTSTR function arguments.  
	CString strPrompt;
	
public:
	
	//-----------------------------------------------------------------------
	// Summary:
	// F O P Master Information, Constructs a CFOPMasterInfo object.
	//		Returns A  value.
	CFOPMasterInfo()
	{
		strName = _T("");
		strPrompt = _T("");
	}
};

#endif // !defined(AFX_FOPVISIOSTENCILHELPER_H__D2447491_E960_4714_BB0B_965507390EAF__INCLUDED_)
