// HMIShapePropSetDlg2.cpp : implementation file
//

#include "stdafx.h"
#include "VisioDraw.h"
#include "HMIShapePropSetDlg2.h"
#include "VisioDrawDoc.h"
#include "VisioDrawView.h"
#include "FOFillEffectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHMIShapePropSetDlg2 dialog


CHMIShapePropSetDlg2::CHMIShapePropSetDlg2(CWnd* pParent /*=NULL*/)
	: CDialog(CHMIShapePropSetDlg2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHMIShapePropSetDlg2)
	m_nArrowLen = 0;
 
	m_bShadow = FALSE;
	m_nShadowWidth = 0;
	m_nArrowWidtth = 0;
	//}}AFX_DATA_INIT
	m_nLineWidth = 1;
	m_nLineType = PS_SOLID;
	nArrowLength = 5;
 
	pOldSelect = NULL;
	nOldSelectCount = 0;
	m_bSelect = FALSE;
	m_bDragging=FALSE;
	savedShadowIndex = 1;
}


void CHMIShapePropSetDlg2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHMIShapePropSetDlg2)
	DDX_Control(pDX, IDC_CHECK_SHADOW, m_check);
	DDX_Control(pDX, IDC_EDIT_SHADOWW, m_edit3);
	DDX_Control(pDX, IDC_EDIT_ARROWWIDTH, m_edit2);
	DDX_Control(pDX, IDC_EDIT_ARROWLEN, m_edit1);
	 
	DDX_Control(pDX, IDC_SPIN_ARROWWIDTH, m_spinArrowWidth);
	DDX_Control(pDX, IDC_SPIN_SHADOW, m_spinShadow);
	DDX_Control(pDX, IDC_BUTTON_DATA, m_btnData);
	 
	DDX_Control(pDX, IDC_SPIN_ARROWLEN, m_spin);
	DDX_Text(pDX, IDC_EDIT_ARROWLEN, m_nArrowLen);
	DDV_MinMaxInt(pDX, m_nArrowLen, 4, 100);
 
	DDX_Check(pDX, IDC_CHECK_SHADOW, m_bShadow);
	DDX_Text(pDX, IDC_EDIT_SHADOWW, m_nShadowWidth);
	DDV_MinMaxInt(pDX, m_nShadowWidth, 1, 100);
	DDX_Text(pDX, IDC_EDIT_ARROWWIDTH, m_nArrowWidtth);
	//}}AFX_DATA_MAP
	 
	DDX_Control(pDX, IDC_BUTTON_LINEWIDTH, m_wndLineWidth);			
	DDX_LineWidthDropDown(pDX, IDC_BUTTON_LINEWIDTH, m_nLineWidth);

	DDX_Control(pDX, IDC_BUTTON_LINETYPE, m_wndLineType);			
	DDX_LineTypeDropDown(pDX, IDC_BUTTON_LINETYPE, m_nLineType);

	DDX_Control(pDX, IDC_BUTTON_LINECOLOR, m_wndLineColor);
	DDX_ColorDropDown(pDX, IDC_BUTTON_LINECOLOR, crLine);

	DDX_Control(pDX, IDC_BUTTON_STARTARROW, m_wndStartArrow);			
	DDX_ArrowDropDown(pDX, IDC_BUTTON_STARTARROW, m_nStartArrow);
	
	DDX_Control(pDX, IDC_BUTTON_ENDARROW, m_wndEndArrow);			
	DDX_ArrowDropDown(pDX, IDC_BUTTON_ENDARROW, m_nEndArrow);
 
	DDX_Control(pDX, IDC_BUTTON_SHADOW, DropShadowButton);			
	DDX_LineWidthDropDown(pDX, IDC_BUTTON_SHADOW, savedShadowIndex);

}


BEGIN_MESSAGE_MAP(CHMIShapePropSetDlg2, CDialog)
	//{{AFX_MSG_MAP(CHMIShapePropSetDlg2)
 
	ON_WM_VSCROLL()
 
	ON_BN_CLICKED(IDC_CHECK_SHADOW, OnCheckShadow)
	ON_EN_CHANGE(IDC_EDIT_SHADOWW, OnChangeEditShadoww)
	ON_EN_CHANGE(IDC_EDIT_ARROWLEN, OnChangeEditArrowlen)
	ON_EN_CHANGE(IDC_EDIT_ARROWWIDTH, OnChangeEditArrowwidth)
 
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_BUTTON_DATA, OnButtonData)
	//}}AFX_MSG_MAP
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()
	ON_WM_SETCURSOR()
 
	ON_CONTROL(FOP_MSG__LINEWIDTH_CHANGE, IDC_BUTTON_LINEWIDTH,	OnLineWidthChange)
	ON_CONTROL(FOP_MSG__LINETYPE_CHANGE, IDC_BUTTON_LINETYPE,	OnLineTypeChange)
	ON_CONTROL(FOP_MSG__COLOR_CHANGE, IDC_BUTTON_LINECOLOR,	OnLineColourChange)

	ON_CONTROL(FOP_MSG__ARROW_CHANGE, IDC_BUTTON_STARTARROW,	OnLineStartChange)
	ON_CONTROL(FOP_MSG__ARROW_CHANGE, IDC_BUTTON_ENDARROW,	OnLineEndChange)
 

	ON_CONTROL(FOP_MSG__SHADOWPICKER_CHANGE, IDC_BUTTON_SHADOW,	OnShadowChange)
  
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHMIShapePropSetDlg2 message handlers

BOOL CHMIShapePropSetDlg2::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
 
	 
	GetDlgItem(IDC_STATIC_LINE)->SetFont(&gfxData.fontBold);
	
	GetDlgItem(IDC_STATIC_DATA)->SetFont(&gfxData.fontBold);
	GetDlgItem(IDC_BUTTON_DATA)->SetFont(&gfxData.fontBold);

	GetDlgItem(IDC_STATIC_SHADOW)->SetFont(&gfxData.fontBold);
  
	m_hCursor1=AfxGetApp()->LoadCursor(IDC_FO_HAND);
	m_hCursor2=AfxGetApp()->LoadCursor(IDC_FO_HAND);
	
	//SetClassLong(m_hWnd,GCL_HCURSOR,(long)m_hCursor1);
	
	// save the original size
	GetWindowRect(m_rcOriginalRect);
	
	// initial scroll position
	m_nScrollPos = 0; 

// 
// 	SCROLLINFO vinfo;
// 	vinfo.cbSize=sizeof(vinfo);
// 	vinfo.fMask=SIF_ALL;
// 	vinfo.nPage=50;
// 	vinfo.nMax=400;//ֵܹ
// 	vinfo.nMin=0;//ܹСֵ
// 	vinfo.nTrackPos=0;
// 	SetScrollInfo(SB_VERT,&vinfo);//ʹһʹôҲʾ

	m_spin.SetBase(10);
	m_spin.SetRange(0,100);
	m_spin.SetPos(nArrowLength);

	m_spinArrowWidth.SetBase(10);
	m_spinArrowWidth.SetRange(0,100);
	m_spinArrowWidth.SetPos(m_nArrowWidtth);

	m_spinShadow.SetBase(10);
	m_spinShadow.SetRange(0,100);
	m_spinShadow.SetPos(m_nShadowWidth);
   
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
 
BOOL FOIsAllDigitsX661(LPCTSTR lpStr)
{
	while (*lpStr != '\0')
	{
		if (!_istdigit(*lpStr++))
		{
			return FALSE;
		}
	}
	return TRUE;
}

void CHMIShapePropSetDlg2::GetAllSelShapes(CFODrawShapeList &mList)
{
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
 
	CFODrawShapeList* pShapeList = pViewTemp->GetSelectShapes();
	if(pShapeList->GetCount() < 1)
			return;

	CFODrawShape *pReturn = NULL;
	POSITION pos = pShapeList->GetHeadPosition();
	while(pos != NULL)
	{
		pReturn = (CFODrawShape *)pShapeList->GetNext(pos);
		
		if(pReturn->IsKindOf(RUNTIME_CLASS(CFOCompositeShape)))
		{
			CFOCompositeShape *pComp = static_cast<CFOCompositeShape *>(pReturn);
			pComp->GetAllShapesInDepth(mList);
		}
		else
		{
			
			mList.AddTail(pReturn);
		}
	}
}

void CHMIShapePropSetDlg2::OnLineTypeChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	// or one of the embedded color wells.
	int nLineType = m_nLineType;
	m_nLineType = m_wndLineType.GetLineType();
	
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		
		if(maList.GetCount() < 1)
			return;
		
		 
		if(nLineType != m_nLineType)
	{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
	 
		pAction->AddShapesInt(maList,m_nLineType, P_ID_PEN_STYLE);
		 
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}
 
void CHMIShapePropSetDlg2::OnLineWidthChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	// or one of the embedded color wells.
	int nLineWidth = m_nLineWidth;
	m_nLineWidth = m_wndLineWidth.GetLineWidth();
	
	
		double nPt = (double)m_nLineWidth;
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		 
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		 
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
			{
				crLine = m_wndLineColor.GetColor();
				int nLineWidth = m_nLineWidth;
				m_nLineWidth = m_wndLineWidth.GetLineWidth();
				
			//	((CExtTabModel *)pModel)->maCurStyle.SetLineColor(crLine);
				((CExtTabModel *)pModel)->maCurStyle.SetLineWidth(m_nLineWidth);
				
			}
			return;
	}
		if(1)//nLineWidth != m_nLineWidth)
	{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		if(m_nLineWidth == 0)
		{
			pAction->AddShapesBool(maList, TRUE, P_ID_NULL_PEN);
			pAction->AddShapesInt(maList,m_nLineWidth, P_ID_LINE_WIDTH);
		}
		else
		{
			pAction->AddShapesBool(maList, FALSE,P_ID_NULL_PEN);
			pAction->AddShapesInt(maList,m_nLineWidth, P_ID_LINE_WIDTH);
		}
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
 
	}
}
 
void CHMIShapePropSetDlg2::OnLineColourChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	crLine = m_wndLineColor.GetColor();
	
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return;

 
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
	if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
	{
		if(!m_bSelect)
		{
			int nLineWidth = m_nLineWidth;
			m_nLineWidth = m_wndLineWidth.GetLineWidth();
 
			 
			((CExtTabModel *)pModel)->maCurStyle.m_crLine = crLine;
			((CExtTabModel *)pModel)->maCurStyle.m_crLineShape = crLine;
			//((CExtTabModel *)pModel)->maCurStyle.SetLineWidth(m_nLineWidth);
			 
		}
		return;
	}
	
	CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
	CRect rc = pViewTemp->GetTotalSelectSnapRect();
	
	pAction->AddShapesColor(maList,crLine, P_ID_LINE_COLOR);
	
	if(pAction->GetActionList()->GetCount() > 0)
	{
		pModel->Do(pAction, TRUE);
		pModel->SetModifiedFlag();
	}
	else
	{
		delete pAction;
		}
	
}

void CHMIShapePropSetDlg2::OnLineStartChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	// or one of the embedded color wells.
	int nLineWidth = m_nStartArrow;
	m_nStartArrow = m_wndStartArrow.GetArrow();
	
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
				((CExtTabModel *)pModel)->maCurStyle.m_nStartArrow = m_nStartArrow;

			return;
		}

		if(1)//nLineWidth != m_nStartArrow)
	{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesInt(maList,m_nStartArrow, P_ID_STARTARROW);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}


void CHMIShapePropSetDlg2::OnLineEndChange()
{
	// We receive this on a color change from one of the well buttons
	if(m_bSelect)
		return;

	// or one of the embedded color wells.
	int nLineWidth = m_nEndArrow;
	m_nEndArrow = m_wndEndArrow.GetArrow();
	
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;

		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
				((CExtTabModel *)pModel)->maCurStyle.m_nEndArrow = m_nEndArrow;
			return;
		}
		if(1)//nLineWidth != m_nEndArrow)
	{
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesInt(maList,m_nEndArrow, P_ID_ENDARROW);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}
 
void CHMIShapePropSetDlg2::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default

	if(HAS_BASE(pScrollBar, CSpinButtonCtrl))
	{
		CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
		return;
	}
	int nDelta;
	int nMaxPos = m_rcOriginalRect.Height() - m_nCurHeight;
	
	switch (nSBCode)
	{
	case SB_LINEDOWN:
		if (m_nScrollPos >= nMaxPos)
			return;
		
		nDelta = min(max(nMaxPos/20,5),nMaxPos-m_nScrollPos);
		break;
		
	case SB_LINEUP:
		if (m_nScrollPos <= 0)
			return;
		nDelta = -min(max(nMaxPos/20,5),m_nScrollPos);
		break;
	case SB_PAGEDOWN:
		if (m_nScrollPos >= nMaxPos)
			return;
		nDelta = min(max(nMaxPos/10,5),nMaxPos-m_nScrollPos);
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		nDelta = (int)nPos - m_nScrollPos;
		break;
		
	case SB_PAGEUP:
		if (m_nScrollPos <= 0)
			return;
		nDelta = -min(max(nMaxPos/10,5),m_nScrollPos);
		break;
		
	default:
		return;
	}
	m_nScrollPos += nDelta;
	SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
	ScrollWindow(0,-nDelta);
	 
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CHMIShapePropSetDlg2::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_bDragging=TRUE;
	SetCapture();
	
	m_ptDragPoint=point;
	
	SetCursor(m_hCursor2);
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CHMIShapePropSetDlg2::OnLButtonUp(UINT nFlags, CPoint point) 
{
	EndDrag();
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CHMIShapePropSetDlg2::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_bDragging)
	{
		int nDelta=m_ptDragPoint.y-point.y;
		m_ptDragPoint=point;
		
		int nNewPos=m_nScrollPos+nDelta;
		
		if (nNewPos<0)
			nNewPos=0;
		else if (nNewPos>m_rcOriginalRect.Height() - m_nCurHeight)
			nNewPos=m_rcOriginalRect.Height() - m_nCurHeight;
		
		nDelta=nNewPos-m_nScrollPos;
		m_nScrollPos=nNewPos;
		
		SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
		ScrollWindow(0,-nDelta);
	}
	
	CDialog::OnMouseMove(nFlags, point);
}

void CHMIShapePropSetDlg2::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
	
	EndDrag();
}

void CHMIShapePropSetDlg2::EndDrag()
{
	m_bDragging=FALSE;
	ReleaseCapture();
	SetCursor(m_hCursor1);
}

BOOL CHMIShapePropSetDlg2::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	BOOL bRet=TRUE;
	
	if (nHitTest==HTCLIENT)
	{
		SetCursor(m_hCursor1);
		bRet=FALSE;
	}
	else
		bRet=CDialog::OnSetCursor(pWnd,nHitTest,message);
	
	return bRet;
}

void CHMIShapePropSetDlg2::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	m_nCurHeight = cy;
	
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_ALL; 
	si.nMin = 0;
	si.nMax = m_rcOriginalRect.Height();
	si.nPage = cy;
	si.nPos = 0;
    SetScrollInfo(SB_VERT, &si, TRUE); 	
	
}
   
void CHMIShapePropSetDlg2::OnShadowChange()
{
	if(m_bSelect)
		return;

	int nShadow = 0;
	nShadow = DropShadowButton.GetShadowPicker();
	if(1)
	{
		CString strText;
		GetDlgItem(IDC_EDIT_SHADOWW)->GetWindowText(strText);
		int nSize = 8;
		if(!strText.IsEmpty())
		{
			nSize = _ttoi(strText);
		}

		if(nShadow == 0)
		{
			// TODO: Add your control notification handler code here
			CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
			if(NULL == pViewTemp)
				return;
			
			CFODataModel* pModel = pViewTemp->GetCurrentModel();
			if(NULL == pModel)
				return;
			
			
			CFODrawShapeList maList;
			GetAllSelShapes(maList);
			if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
			{
				if(!m_bSelect)
					((CExtTabModel *)pModel)->maCurStyle.SetShadow(FALSE);
				return;
			}
			
			CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
			CRect rc = pViewTemp->GetTotalSelectSnapRect();
			
			pAction->AddShapesBool(maList,FALSE, P_ID_SHADOW);
		 
		//	pAction->AddShapesInt(*pShapeList,0, P_ID_SHADOW_BRUSHTYPE);
			 
			if(pAction->GetActionList()->GetCount() > 0)
			{
				pModel->Do(pAction, TRUE);
				pModel->SetModifiedFlag();
			}
			else
			{
				delete pAction;
			}
		}
		else
		{
			int nX = 5;
			int nY = 5;

			switch(nShadow)
			{
			case 1:
				{
					nX = -nSize;
					nY = -nSize;
				}
				break;
			case 2:
				{
					nX = nSize;
					nY = nSize;
				}
				break;
				

			case 3:
				{
					nX = -nSize;
					nY = nSize;
				}
				break;
				

			case 4:
				{
					nX = nSize;
					nY = -nSize;
				}
				break;

			default:
				break;
			}
				
			
			CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
			if(NULL == pViewTemp)
				return;
			
			CFODataModel* pModel = pViewTemp->GetCurrentModel();
			if(NULL == pModel)
				return;
			
			
			CFODrawShapeList maList;
			GetAllSelShapes(maList);
			if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
				return;
			
			CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
			CRect rc = pViewTemp->GetTotalSelectSnapRect();
			pAction->AddShapesBool(maList,TRUE, P_ID_SHADOW);
			pAction->AddShapesInt(maList,nX, P_ID_SHADOW_OFFSETX);
			pAction->AddShapesInt(maList,nY, P_ID_SHADOW_OFFSETY);
			
			if(pAction->GetActionList()->GetCount() > 0)
			{
				pModel->Do(pAction, TRUE);
				pModel->SetModifiedFlag();
			}
			else
			{
				delete pAction;
			}
			
		}
	}
}

void CHMIShapePropSetDlg2::OnCheckShadow() 
{
	// TODO: Add your control notification handler code here
	BOOL bCheck = ((CButton *)GetDlgItem(IDC_CHECK_SHADOW))->GetCheck();
 
	if(1)
	{
	 
		// TODO: Add your control notification handler code here
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
		{
			if(!m_bSelect)
				((CExtTabModel *)pModel)->maCurStyle.SetShadow(bCheck);
			return;
		}
		
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesBool(maList,bCheck, P_ID_SHADOW);
		if(bCheck)
		{
			pAction->AddShapesInt(maList,1, P_ID_SHADOW_BRUSHTYPE);
		}
		else
		{
			pAction->AddShapesInt(maList,0, P_ID_SHADOW_BRUSHTYPE);
		}
	 
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}

void CHMIShapePropSetDlg2::OnChangeEditShadoww() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	if(m_bSelect)
		return;

	// TODO: Add your control notification handler code here
	CString strText;
	GetDlgItem(IDC_EDIT_SHADOWW)->GetWindowText(strText);
	if(!strText.IsEmpty())
	{
		int nSize = _ttoi(strText);
		// TODO: Add your control notification handler code here
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
			return;
		
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		int nShadow = 0;
		nShadow = DropShadowButton.GetShadowPicker();

		int nX = nSize;
		int nY = nSize;
		
		switch(nShadow)
		{
		case 1:
			{
				nX = -nSize;
				nY = -nSize;
			}
			break;
		case 2:
			{
				nX = nSize;
				nY = nSize;
			}
			break;
			
			
		case 3:
			{
				nX = -nSize;
				nY = nSize;
			}
			break;
			
			
		case 4:
			{
				nX = nSize;
				nY = -nSize;
			}
			break;
			
		default:
			break;
			}

		pAction->AddShapesInt(maList,nX, P_ID_SHADOW_OFFSETX);
		pAction->AddShapesInt(maList,nY, P_ID_SHADOW_OFFSETY);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}

void CHMIShapePropSetDlg2::OnChangeEditArrowlen() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	if(m_bSelect)
		return;

	CString strText;
	GetDlgItem(IDC_EDIT_ARROWLEN)->GetWindowText(strText);
	if(!strText.IsEmpty())
	{
		int nSize = _ttoi(strText);
		// TODO: Add your control notification handler code here
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
			return;
		
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesInt(maList,nSize, P_ID_ENDARROWLENGTH);
		pAction->AddShapesInt(maList,nSize, P_ID_STARTARROWLENGTH);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
	
}

void CHMIShapePropSetDlg2::UpdateProperty(CFODrawView* pView, const BOOL &bWithAction)
{
	
	CWnd *pParent = GetParent();
	if(!pParent->IsWindowVisible())
		return;
 
	CFODataModel* pModel = pView->GetCurrentModel();
	if(NULL == pModel)
		return;

	BOOL bDoNotUpdate = FALSE;
	BOOL bDoNotUpdateCanvas = FALSE;
	CFODrawShape *pShape = NULL;
	CFODrawShapeList maList;
	GetAllSelShapes(maList);
		 
	int nCurTotal = maList.GetCount();
	if(nCurTotal > 0)
	{
		pShape = (CFODrawShape *)maList.GetHead();
	}

	if(nCurTotal == 1)
	{
		if(pShape == pOldSelect && nOldSelectCount == 1)
		{
			bDoNotUpdate = TRUE;
		}
	}

	if(nCurTotal == 0)
	{
		bDoNotUpdate = TRUE;
	}

	if(nCurTotal == 0 && nOldSelectCount == 0)
	{
		bDoNotUpdateCanvas = TRUE;
	}

	BOOL bRedrawDrawCanvas = TRUE;
	if(pOldSelect != NULL && pShape == pOldSelect && nOldSelectCount == 1)
	{
		bRedrawDrawCanvas = FALSE;
	}

	nOldSelectCount = nCurTotal;
	pOldSelect = pShape;
 
	if(NULL == pModel || FALSE == pModel->IsDesignMode())
		return;

	if(bDoNotUpdate && !bWithAction)
	{
		return;
	}

	if(pShape == NULL)
	{
		return;
	}

	m_bSelect = TRUE;
//	Use the First Shape.
	 
	m_wndLineWidth.SetLineWidth((short)pShape->GetLineWidth());
	m_wndLineType.SetLineType((short)pShape->GetPenStyle());
	m_wndLineColor.SetColor(pShape->GetLineColor());
	m_wndStartArrow.SetArrow((short)pShape->GetStartArrowType());
	m_wndEndArrow.SetArrow((short)pShape->GetEndArrowType());

	CString strTemp;
	if(pShape->GetStartArrowType() > 0)
	{
		strTemp.Format(_T("%u"), (short)pShape->GetStartArrowLength());
		GetDlgItem(IDC_EDIT_ARROWLEN)->SetWindowText(strTemp);

		strTemp.Format(_T("%u"), (short)pShape->GetStartArrowWidth());
		GetDlgItem(IDC_EDIT_ARROWWIDTH)->SetWindowText(strTemp);
	}
	else if(pShape->GetStartArrowType() > 0)
	{
		strTemp.Format(_T("%u"), (short)pShape->GetEndArrowLength());
		GetDlgItem(IDC_EDIT_ARROWLEN)->SetWindowText(strTemp);
		
		strTemp.Format(_T("%u"), (short)pShape->GetEndArrowWidth());
		GetDlgItem(IDC_EDIT_ARROWWIDTH)->SetWindowText(strTemp);
	}
    
	((CButton *)GetDlgItem(IDC_CHECK_SHADOW))->SetCheck(TRUE == pShape->GetShadow());

	int nx = pShape->GetShadowOffsetX();
	int ny = pShape->GetShadowOffsetY();
	int nShadow = 0;
	if(nx > 0)
	{
		if(ny > 0)
		{
			nShadow = 2;
		}
		else
		{
			nShadow = 4;
		}
	}
	else
	{
		if(ny > 0)
		{
			nShadow = 3;
		}
		else
		{
			nShadow = 1;
		}
	}

	DropShadowButton.SetShadowPicker(nShadow);

	strTemp.Format(_T("%u"), (short)pShape->GetShadowOffsetX());
	GetDlgItem(IDC_EDIT_SHADOWW)->SetWindowText(strTemp);

	m_bSelect = FALSE;
}

void CHMIShapePropSetDlg2::OnChangeEditArrowwidth() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	if(m_bSelect)
		return;

	// TODO: Add your control notification handler code here
	CString strText;
	GetDlgItem(IDC_EDIT_ARROWWIDTH)->GetWindowText(strText);
	if(!strText.IsEmpty())
	{
		int nSize = _ttoi(strText);
		// TODO: Add your control notification handler code here
		CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
		if(NULL == pViewTemp)
			return;
		
		CFODataModel* pModel = pViewTemp->GetCurrentModel();
		if(NULL == pModel)
			return;
		
		CFODrawShapeList maList;
		GetAllSelShapes(maList);
		if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
			return;
		
		CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
		CRect rc = pViewTemp->GetTotalSelectSnapRect();
		
		pAction->AddShapesInt(maList,nSize, P_ID_ENDARROWWIDTH);
		pAction->AddShapesInt(maList,nSize, P_ID_STARTARROWWIDTH);
		
		if(pAction->GetActionList()->GetCount() > 0)
		{
			pModel->Do(pAction, TRUE);
			pModel->SetModifiedFlag();
		}
		else
		{
			delete pAction;
		}
	}
}
 
BOOL CHMIShapePropSetDlg2::SetScrollPos32(int nBar, int nPos, BOOL bRedraw)
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask  = SIF_POS;
	si.nPos   = nPos;
	SetScrollInfo(nBar, &si, bRedraw);

	
	return TRUE;
}

int CHMIShapePropSetDlg2::GetScrollPos32( int nBar, BOOL bGetTrackPos )
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	
	if(bGetTrackPos)
    {
		if(GetScrollInfo(nBar, &si, SIF_TRACKPOS))
			return si.nTrackPos;
    }
	else
    {
		if(GetScrollInfo(nBar, &si, SIF_POS))
			return si.nPos;
    }
	
	return 0;
}

BOOL CHMIShapePropSetDlg2::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
 
// 	int nMaxPos = m_rcOriginalRect.Height() - m_nCurHeight;
// 	
// 	if (zDelta<0)
// 	{
// 		if (m_nScrollPos < nMaxPos)
// 		{
// 			zDelta = min(max(nMaxPos/20,5),nMaxPos-m_nScrollPos);
// 			
// 			m_nScrollPos += zDelta;
// 			SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
// 			ScrollWindow(0,-zDelta);
// 		}
// 	}
// 	else
// 	{
// 		if (m_nScrollPos > 0)
// 		{
// 			zDelta = -min(max(nMaxPos/20,5),m_nScrollPos);
// 			
// 			m_nScrollPos += zDelta;
// 			SetScrollPos(SB_VERT,m_nScrollPos,TRUE);
// 			ScrollWindow(0,-zDelta);
// 		}
// 	}
	
 
	 
	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}
 
BOOL CHMIShapePropSetDlg2::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if((pMsg->message == WM_KEYDOWN)&&(pMsg->wParam == VK_RETURN))
	{
		CWnd *pWnd = (CWnd *)GetFocus()->GetParent();
		 if(pWnd->GetSafeHwnd() == m_edit1.GetSafeHwnd())
		{
			CString strText;
			GetDlgItem(IDC_EDIT_ARROWLEN)->GetWindowText(strText);
			if(!strText.IsEmpty())
			{
				int nSize = _ttoi(strText);
				// TODO: Add your control notification handler code here
				CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
				if(NULL == pViewTemp)
					return TRUE;
				
				CFODataModel* pModel = pViewTemp->GetCurrentModel();
				if(NULL == pModel)
					return TRUE;
				
				CFODrawShapeList maList;
				GetAllSelShapes(maList);
				if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
					return TRUE;
				
				CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
				CRect rc = pViewTemp->GetTotalSelectSnapRect();
				
				pAction->AddShapesInt(maList,nSize, P_ID_ENDARROWLENGTH);
				pAction->AddShapesInt(maList,nSize, P_ID_STARTARROWLENGTH);
				
				if(pAction->GetActionList()->GetCount() > 0)
				{
					pModel->Do(pAction, TRUE);
					pModel->SetModifiedFlag();
				}
				else
				{
					delete pAction;
				}
			}

			return TRUE;
		}
		else if(pWnd->GetSafeHwnd() == m_edit2.GetSafeHwnd())
		{
			CString strText;
			GetDlgItem(IDC_EDIT_ARROWWIDTH)->GetWindowText(strText);
			if(!strText.IsEmpty())
			{
				int nSize = _ttoi(strText);
				// TODO: Add your control notification handler code here
				CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
				if(NULL == pViewTemp)
					return TRUE;
				
				CFODataModel* pModel = pViewTemp->GetCurrentModel();
				if(NULL == pModel)
					return TRUE;
				
				CFODrawShapeList maList;
				GetAllSelShapes(maList);
				if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
					return TRUE;
				
				CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
				CRect rc = pViewTemp->GetTotalSelectSnapRect();
				
				pAction->AddShapesInt(maList,nSize, P_ID_ENDARROWWIDTH);
				pAction->AddShapesInt(maList,nSize, P_ID_STARTARROWWIDTH);
				
				if(pAction->GetActionList()->GetCount() > 0)
				{
					pModel->Do(pAction, TRUE);
					pModel->SetModifiedFlag();
				}
				else
				{
					delete pAction;
				}
			}

			return TRUE;
		}
		else if(pWnd->GetSafeHwnd() == m_edit3.GetSafeHwnd())
		{
			CString strText;
			GetDlgItem(IDC_EDIT_SHADOWW)->GetWindowText(strText);
			if(!strText.IsEmpty())
			{
				int nSize = _ttoi(strText);
				// TODO: Add your control notification handler code here
				CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
				if(NULL == pViewTemp)
					return TRUE;
				
				CFODataModel* pModel = pViewTemp->GetCurrentModel();
				if(NULL == pModel)
					return TRUE;
				
				
				CFODrawShapeList maList;
				GetAllSelShapes(maList);
				if(maList.GetCount() < 1 || pViewTemp->GetDrawType() != FO_COMP_NONE)
					return TRUE;
				
				CFOMultiShapePropAction* pAction = pModel->GetShapesPropAction();
				CRect rc = pViewTemp->GetTotalSelectSnapRect();
				int nShadow = 0;
				nShadow = DropShadowButton.GetShadowPicker();
				
				int nX = nSize;
				int nY = nSize;
				
				switch(nShadow)
				{
				case 1:
					{
						nX = -nSize;
						nY = -nSize;
					}
					break;
				case 2:
					{
						nX = nSize;
						nY = nSize;
					}
					break;
					
					
				case 3:
					{
						nX = -nSize;
						nY = nSize;
					}
					break;
					
					
				case 4:
					{
						nX = nSize;
						nY = -nSize;
					}
					break;
					
				default:
					break;
				}
				
				pAction->AddShapesInt(maList,nX, P_ID_SHADOW_OFFSETX);
				pAction->AddShapesInt(maList,nY, P_ID_SHADOW_OFFSETY);
				
				if(pAction->GetActionList()->GetCount() > 0)
				{
					pModel->Do(pAction, TRUE);
					pModel->SetModifiedFlag();
				}
				else
				{
					delete pAction;
				}
			}

			return TRUE;
		}

		return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CHMIShapePropSetDlg2::OnButtonData() 
{
	// TODO: Add your control notification handler code here
	CVisioDrawView *pViewTemp =(CVisioDrawView*)FOGetActiveView();
	if(NULL == pViewTemp)
		return;
	
	CFODataModel* pModel = pViewTemp->GetCurrentModel();
	if(NULL == pModel)
		return;
	
 
	CFODrawShapeList* pShapeList = pViewTemp->GetSelectShapes();
	if(pShapeList->GetCount() != 1)
			return;
 
    CFOPPropEditDlg dlg;
	dlg.m_pShape = pShapeList->GetHead();
	//  dlg.m_bWithUser = FALSE;
	dlg.DoModal();
	
	
}
